Ruby: include/ruby/internal/arithmetic/st_data_t.h File Reference

Ruby 3.4.4p34 (2025-05-14 revision a38531fd3f617bf734ef7d6c595325f69985ea1d)

Macros | Functions
st_data_t.h File Reference

Arithmetic conversion between C's `st_data_t` and Ruby's. More...

`#include "ruby/internal/arithmetic/fixnum.h"`
`#include "ruby/internal/arithmetic/long.h"`
`#include "ruby/internal/attr/artificial.h"`
`#include "ruby/internal/attr/const.h"`
`#include "ruby/internal/attr/constexpr.h"`
`#include "ruby/internal/cast.h"`
`#include "ruby/internal/value.h"`
`#include "ruby/assert.h"`
`#include "ruby/st.h"`

Go to the source code of this file.

## Macros
#define | ST2FIX RB_ST2FIX
| Old name of RB_ST2FIX.

## Functions
static VALUE | RB_ST2FIX (st_data_t i)
| Converts a C's `st_data_t` into an instance of rb_cInteger.

## Detailed Description

Arithmetic conversion between C's `st_data_t` and Ruby's.

Author
  Ruby developers ruby-.nosp@m.core.nosp@m.@ruby.nosp@m.-lan.nosp@m.g.org

Copyright
  This file is a part of the programming language Ruby. Permission is hereby granted, to either redistribute and/or modify this file, provided that the conditions mentioned in the file COPYING are met. Consult the file for details.

Warning
  Symbols prefixed with either `RBIMPL` or `rbimpl` are implementation details. Don't take them as canon. They could rapidly appear then vanish. The name (path) of this header file is also an implementation detail. Do not expect it to persist at the place it is now. Developers are free to move it anywhere anytime at will.

Note
  To ruby-core: remember that this header can be possibly recursively included from extension libraries written in C++. Do not expect for instance `__VA_ARGS__` is always available. We assume C99 for ruby itself but we don't assume languages of extension libraries. They could be written in C++98.

Definition in file st_data_t.h.

## Function Documentation

## ◆ RB_ST2FIX()

static VALUE RB_ST2FIX | ( | st_data_t | i | ) |
| inlinestatic

Converts a C's `st_data_t` into an instance of rb_cInteger.

Parameters

  [in] | i | The data in question.

Returns
  A converted result

Warning
  THIS CONVERSION LOSES DATA! Be warned.

See also
  https://bugs.ruby-lang.org/issues/13877
  https://bugs.ruby-lang.org/issues/14218

Definition at line 59 of file st_data_t.h.

Referenced by RB_ST2FIX().